"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = require("prop-types");

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var DEFAULT_BREAKPOINTS = ['576px', '768px', '992px', '1200px'];

var Base = _styledComponents.default.div(function (props) {
  return transform(props.css, props.theme);
});

function transform(css, theme) {
  if (!css) return null;
  var breakpoints = [null].concat(_toConsumableArray((get('breakpoints', theme) || DEFAULT_BREAKPOINTS).map(toMediaQuery)));
  return Object.entries(css).reduce(function (acc, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        property = _ref2[0],
        value = _ref2[1];

    if (Array.isArray(value)) {
      var declarations = value.reduce(function (declarations, currentValue, index) {
        if (index >= breakpoints.length) return declarations;

        if (breakpoints[index]) {
          declarations[breakpoints[index]] = _objectSpread({}, acc[breakpoints[index]], _defineProperty({}, property, supplant(currentValue, theme)));
        } else {
          declarations[property] = supplant(currentValue, theme);
        }

        return declarations;
      }, {});
      return _objectSpread({}, acc, declarations);
    }

    if (_typeof(value) === 'object') {
      return _objectSpread({}, acc, _defineProperty({}, property, transform(value, theme)));
    }

    return _objectSpread({}, acc, _defineProperty({}, property, supplant(value, theme)));
  }, {});
}

function supplant(value, obj) {
  if (typeof value !== 'string') return value;
  return value.replace(/\$[(a-z)(A-Z)(0-9)(.)]+/g, function (match) {
    return get(match.slice(1), obj) || match;
  });
}

function get(path, obj) {
  return path.split('.').reduce(function (acc, key) {
    return acc && acc[key] ? acc[key] : null;
  }, obj);
}

function toMediaQuery(value) {
  return "@media screen and (min-width: ".concat(value, ")");
}

Base.propTypes = {
  /** Style object */
  css: _propTypes.object
};
var _default = Base;
exports.default = _default;